<?php

namespace Teknisa\OPL\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;
use Teknisa\OPL\Services\SaidaOperadorLogisticoService;
    
class Dfs48000SaidaDoOperadorLogisticoController extends \Teknisa\OPL\Controllers\TeknisaCrud {
    
    protected $saidaDoOperadorLogisticoService;
    protected $dataSourceName = 'dfs48000_saida_notafiscal';
    protected $entityManager;
    protected $environment;
    
    public function __construct(SaidaDoOperadorLogisticoService $saidaDoOperadorLogisticoService) {
        $this->saidaDoOperadorLogisticoService = saidaoDoOperadorLogisticoService;
    }
    
    public function gerarSaida(DTO\Request\DataSet $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        
        $notasFiscais    = $dataSet->getRows()[0];
        $dadosDevolucao  = $dataSet->getRows()[1];
        $dadosAdicionais = $dataSet->getRows()[2];
        
        
        $this->saidaDoOperadorLogisticoService->gerarSaida($notasFiscais, $dadosSaida, $dadosAdicionais);
        
        $erros = $this->saidaOperadorLogisticoService->getErros();
        $numNotasSucesso = $this->saidaOperadorLogisticoService->getQtNotasSucesso();
        $response->addDataset(new DataSource\DataSet('errosSaida', $erros));
        if($numNotasSucesso != 0) {
            $response->addMessage(new Response\Message($numNotasSucesso));
        }
        else {
            $response->addMessage(new Response\Message("Não foi possível realizar a saída das notas fiscais selecionadas."));
        }
    
    }


}
