<?php
namespace Fiscal\Logic\Apuracoes;

use Geral\Util\DateUtil;
use Geral\Util\TratamentoDeMensagens;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Fiscal\Entities\Paramfiscal;
use \Fiscal\Entities\Mapaapurac;
use \Fiscal\Entities\Itdetapucontr;
use \Fiscal\Entities\Impostonf;
use \Fiscal\Entities\Livromagnetico;
use \Indeterminado\Entities\Impostonfe;
use \Indeterminado\Entities\Detapuracontr;
use \Indeterminado\Entities\Ajusteapurcontr;
use \Indeterminado\Entities\Guiacompapucontr;
use \Indeterminado\Repositories\Outreccontctbl;
use \Geral\Entities\Contctbl;
use \Fiscal\Logic\Apuracoes\Exceptions\ExcecaoContribuicoes;
use \Setforms2\Shared\Registry;

class Contribuicoes{

    public static function sugereData($imposto, $empresa, $nrorg){
        /** @var $MaiorData \Fiscal\Repositories\Mapaapurac */
        $MaiorData = \Fiscal\Repositories\Mapaapurac::maiorData($imposto, $empresa, $nrorg);

        tk_disable_field('DTINIPERIODO');

        if (($MaiorData == null) or ($MaiorData == '1')){
         //   tk_set_field_value('DTINIPERIODO', '01/01/2011');
            tk_enable_field('DTINIPERIODO');
        }
        else{
            tk_set_field_value('DTINIPERIODO', $MaiorData);
        }
        return $MaiorData;
    }

    public static function ValidaDatas($DataInicio, $nrorg){
        /** @var $Paramfiscal \Fiscal\Repositories\Paramfiscal */
        $Paramfiscal = Paramfiscal::verifDataParamFiscal($nrorg);

        if ($DataInicio != null && $Paramfiscal != null ) {
            $inicial = \Geral\Util\DateUtil::getDataDeString($DataInicio);
            $final = \Geral\Util\DateUtil::getDataDeString($Paramfiscal, DateUtil::FORMATO_BRASILEIRO_DATAHORA);

            $inicial = \Geral\Util\DateUtil::truncateData($inicial);
            $final = \Geral\Util\DateUtil::truncateData($final);

            if (\Geral\Util\DateUtil::comparaDatas($inicial, $final, DateUtil::DEPOIS) == false) {
                ExcecaoContribuicoes::Validacao01();
            }
        }
        if ($DataInicio <= $Paramfiscal){
            ExcecaoContribuicoes::Validacao01();
        }
    }

    public static function executaProcedure($dtinicial, $dtfinal, $idimporecupnfe, $cdimpostonfe, $nrsequmapapu, $cdempresa, $nrorg)
    {
//        self::bloqueiaApuracao($nrsequmapapu, $nrorg);

        $procedure = new Procedure('GERA_APURACAO_CONTRIBUICOES');
        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $dtinicial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $dtfinal, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDIMPORECUPNFE', Param::PARAM_INPUT, $idimporecupnfe, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDIMPOSTONFE', Param::PARAM_INPUT, $cdimpostonfe, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSEQUMAPAPU', Param::PARAM_INPUT, $nrsequmapapu, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
   //     $procedure->addParam(new Param('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_STR));
        $procedure->call();
    }

    /*public static function posProced($nrsequmapapu, $cdimpostonfe){
        $nrorg = \Geral\Util\Ambiente::getNrorg();
        $cdparfiscal = 1;

        /** @var $dtininfforper \Fiscal\Entities\Paramfiscal */
//        $dtininfforper = \Fiscal\Entities\Paramfiscal::findOneByCdparfiscalAndNrorg($cdparfiscal,$nrorg);
//        $dtininfforper = $dtininfforper->getDtininfforper();
//        $dtininfforper = \Geral\Util\DateUtil::truncateString($dtininfforper);
//        $dtininfforper = \Geral\Util\DateUtil::getDataDeString($dtininfforper);
//        $dtininfforper = \Geral\Util\DateUtil::truncateData($dtininfforper);

        /** @var $idformapurnfe \Indeterminado\Entities\Impostonfe */
//        $impostonfe = \Indeterminado\Entities\Impostonfe::findOneByCdimpostonfeAndNrorg($cdimpostonfe, $nrorg);
//        $idformapurnfe = $impostonfe->getIdformapurnfe();

        /** @var $PosProced01 \Fiscal\Repositories\Mapaapurac */
//        $PosProced01 = \Fiscal\Repositories\Mapaapurac::posProcedure01($dtininfforper, $nrsequmapapu, $idformapurnfe, $cdimpostonfe);

        /** @var $PosProced02 \Fiscal\Repositories\Mapaapurac */
//        $PosProced02 = \Fiscal\Repositories\Mapaapurac::posProcedure02($dtininfforper, $nrsequmapapu);

//        if (($PosProced01 != null) or ($PosProced02 != null)){
//            ExcecaoContribuicoes::Validacao03();
//        }
//    }*/

    public static function bloquearMapa($dtinicial, $dtfinal, $idimporecupnfe, $cdimpostonfe, $nrsequmapapu, $cdempresa, $nrorg){

        /* Verifica se todos os mapas anteriores a este estÃ£o bloqueados. */
        $mapaapurac = Mapaapurac::getObjectsByWhere("CDEMPRESA = ?
                                                                      AND CDIMPOSTO = ?
                                                                      AND DTINIPERIODO < ?
                                                                      AND IDBLOQMAPAPU IN ('N','A')
                                                                      AND NRORG = ?",
                                                                      array ($cdempresa, $cdimpostonfe, $dtinicial, $nrorg));
        /*Caso tenha algum mapa desbloqueado exibe uma mensagem e nÃ£o bloqueia o mapa.*/
        if ($mapaapurac != null) {
            ExcecaoContribuicoes::Validacao05();
        }
        else {

            self::bloqueiaApuracao($nrsequmapapu, $nrorg);

            /*Faz nova apuraÃ§Ã£o, bloqueia o mapa e recarrega os mapas da tela para atualizar o campo de status.*/
            self::executaProcedure($dtinicial, $dtfinal, $idimporecupnfe, $cdimpostonfe, $nrsequmapapu, $cdempresa, $nrorg);

            /** @var $mapaapurac \Fiscal\Entities\Mapaapurac */
            $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            $mapaapurac->setIdbloqmapapu('S');

            $mapaapurac->persist();
            Registry::getEntityManager()->flush();

            /*Recarrega os dados da tela com o filtro para atualizar o status do mapa.*/
            tk_reload_data_with_filter('tab_pbi00136_000_MapaDeApuracao', 'win_pbi00136_000');
        }
    }

    public static function bloquearAlteracoes($nrsequmapapu, $nrorg){
        /** @var $mapaapurac \Fiscal\Entities\Mapaapurac */
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
        
        if ($mapaapurac->getIdbloqmapapu() == 'S'){
            ExcecaoContribuicoes::Validacao04();
        }

    }

    public static function desbloquearMapa($cdempresa, $cdimpostonfe, $dtfinal, $nrsequmapapu, $nrorg){

        /* Verifica se todos os mapas anteriores a este estÃ£o desbloqueados. */
        $mapaapurac = Mapaapurac::getObjectsByWhere("CDEMPRESA = ?
                                                                      AND CDIMPOSTO = ?
                                                                      AND DTFIMPERIODO > ?
                                                                      AND IDBLOQMAPAPU = 'S'
                                                                      AND NRORG = ?",
                                                                      array ($cdempresa, $cdimpostonfe, $dtfinal, $nrorg));
        /*Caso tenha algum mapa bloqueado exibe uma mensagem e nÃ£o desbloqueia o mapa.*/
        if ($mapaapurac != null) {
            ExcecaoContribuicoes::Validacao06();
        }
        else {
            /*Desbloqueia o mapa e recarrega os mapas da tela para atualizar o campo de status.*/
            /** @var $mapaapurac \Fiscal\Entities\Mapaapurac */
            $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            $mapaapurac->setIdbloqmapapu('A');

            $mapaapurac->persist();
            Registry::getEntityManager()->flush();

            /*Recarrega os dados da tela com o filtro para atualizar o status do mapa.*/
            tk_reload_data_with_filter('tab_pbi00136_000_MapaDeApuracao', 'win_pbi00136_000');
        }
    }

    public static function bloqueiaApuracao($nrsequmapapu, $nrorg){
        /*nÃ£o permite Bloqueiar o mapa caso nÃ£o tenham sido informados a data de vencimento e o cÃ³digo da receita da guia de contribuiÃ§Ã£o.*/
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu,$nrorg);
        $detapuracontr = Detapuracontr::findOneByNrsequmapapuAndNrorg($nrsequmapapu,$nrorg);

        try{
            if ($mapaapurac->getDtvencguia() == null) {
                tk_focus_tab('tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                //tk_set_focus_field('DTVENCGUIA','tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                ExcecaoContribuicoes::Validacao07();
            }
            else if (($mapaapurac->getCdrececumu() == null) && ($detapuracontr->getVrdebcumula() > 0)) {
                tk_focus_tab('tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                //tk_set_focus_field('CDRECEITACONTR','tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                ExcecaoContribuicoes::Validacao08();
            }
            else if (($mapaapurac->getCdrecencumu() == null) && ($detapuracontr->getVrdebncumula() > 0)) {
                tk_focus_tab('tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                //tk_set_focus_field('CDRECEITACONTR','tab_pbi00136_000_GuiaContribuicao','win_pbi00136_000');
                ExcecaoContribuicoes::Validacao12();
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function atualizaSaldo($nrsequmapapu,$nrorg){
        /*Faz o calculo para atualizar os valores do imposto a recolher, saldo credor e valor da guia de contribuiÃ§Ã£o do mapa.*/
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu,$nrorg);
        $detapuracontr = Detapuracontr::findOneByNrsequmapapuAndNrorg($nrsequmapapu,$nrorg);

        /*CrÃ©dito*/
        $vrcredperant = \Fiscal\Repositories\Itdetapucontr::getTotalCredAnt($nrsequmapapu,$nrorg);
        $detapuracontr->setVrcredperant($vrcredperant);
        $vrcredentr = $detapuracontr->getVrcredentr();
        $vrcreddevol = $detapuracontr->getVrcreddevol();
        $vrcredativimob = $detapuracontr->getVrcredativimob();
        $vrajustecred = Ajusteapurcontr::getTotalCred($nrsequmapapu,$nrorg);
        /*SÃ£o somados o valor do crÃ©dito anterior, crÃ©dito de entradas, crÃ©dito de devoluÃ§Ãµes, crÃ©dito do ativo e os ajustes de reduÃ§Ã£o.*/
        $vrtotacred = $vrcredperant + $vrcredentr + $vrcreddevol + $vrcredativimob + $vrajustecred;

        /*DÃ©bito*/
        $vrdebncumula = $detapuracontr->getVrdebncumula();
        $vrdebcumula = $detapuracontr->getVrdebcumula();
        $vrdebidevol = $detapuracontr->getVrdebidevol();
        $vrdebecf = $detapuracontr->getVrdebecf();
        $vrajustedeb = Ajusteapurcontr::getTotalDeb($nrsequmapapu,$nrorg);
        /*SÃ£o somados os dÃ©bitos de saÃ­das cumulativas e nÃ£o cumulativas, dÃ©bitos de devoluÃ§Ãµes, dÃ©bitos de ecf e os ajustes de acrÃ©scimo.*/
        $vrtotadeb = $vrdebncumula + $vrdebcumula + $vrdebidevol + $vrdebecf + $vrajustedeb;

        /*Guia ContribuiÃ§Ã£o*/
        $vrjuroguia = $mapaapurac->getVrjuroguia();
        $vrmultaguia = $mapaapurac->getVrmultaguia();

        /*CÃ¡lculo*/
        $vrdebcred = $vrtotadeb - $vrtotacred;
        $vrcompensa = \Fiscal\Repositories\Itdetapucontr::getTotalCompensacao($nrsequmapapu,$nrorg);
        $detapuracontr->setVrcompensa($vrcompensa);
        $vrdeducao = \Fiscal\Repositories\Itdetapucontr::getTotalDeducao($nrsequmapapu,$nrorg);
        $detapuracontr->setVrdeducao($vrdeducao);
        /*Ã‰ feito o cÃ¡lculo de dÃ©bito menos crÃ©dito, retirando ainda as compensaÃ§Ãµes e deduÃ§Ãµes para verificar se houve saldo devedor (>0) ou credor(<0).*/
        $saldo = abs($vrdebcred) - $vrcompensa - $vrdeducao;

        if (($saldo >= 0) && ($vrdebcred > 0)) {
            /*Caso o saldo seja maior que zero, o dÃ©bito Ã© maior que o crÃ©dito, serÃ¡ gerado um valor de imposto a recolher.*/
            $mapaapurac->setVrtotaimpos($saldo);
            $detapuracontr->setVrsaldocred(0);

            /*O valor Ã© transportado para a guia de contribuiÃ§Ã£o considerando os juros e multa se houver.*/
            $vrtotaguia = $saldo + $vrjuroguia + $vrmultaguia;
            $mapaapurac->setVrtotaguia($vrtotaguia);

        }
        else {
            /*Caso o saldo seja negativo, o crÃ©dito Ã© maior que o dÃ©bito, serÃ¡ gerado um saldo credor.*/
            $mapaapurac->setVrtotaimpos(0);
            if ($saldo < 0){
                $saldo = 0;
            }
            $detapuracontr->setVrsaldocred($saldo);

            /*O valor da guia serÃ¡ somente o valor dos juros e da multa caso o cliente tenha informado.*/
            $vrtotaguia = $vrjuroguia + $vrmultaguia;
            $mapaapurac->setVrtotaguia($vrtotaguia);
        }

        $mapaapurac->persist();
        $detapuracontr->persist();
        Registry::getEntityManager()->flush();
    }

    public static function calculaValorGuia($nrsequmapapu,$nrorg,$vrjuroguia,$vrmultaguia){
        /*Calcula o valor da guia somando o valor dos juros e da multa informados ao valor do imposto a recolher do mapa.*/
        $mapaapurac = Mapaapurac::findOneByNrsequmapapuAndNrorg($nrsequmapapu,$nrorg);

        $vrtotaimpos = $mapaapurac->getVrtotaimpos();
        $vrtotaguia = $vrtotaimpos + $vrjuroguia + $vrmultaguia;

        $mapaapurac->setVrtotaguia($vrtotaguia);

        $mapaapurac->persist();
        Registry::getEntityManager()->flush();
    }

    public static function limpaDadosMapa($nrsequmapapu, $nrorg){
        /*Limpa todos os dados das tabelas referentes ao mapa.*/

        $connection = Registry::getEntityManagerConnection();
        $connection->beginTransaction();

        try{
            /*Guia Complementar*/
            $guiacompapucontr = Guiacompapucontr::findByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            if (is_array($guiacompapucontr)) {
                foreach ($guiacompapucontr as $registro) {
                    $registro->delete();
                }

            }

            /*Item do Detalhamento do Mapa*/
            $itdetapucontr = Itdetapucontr::findByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            if (is_array($itdetapucontr)) {
                foreach ($itdetapucontr as $registro) {
                    $registro->delete();
                }
            }

            /*Detalhamento do Mapa*/
            $detapuracontr = Detapuracontr::findByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            if (is_array($detapuracontr)) {
                foreach ($detapuracontr as $registro) {
                    $registro->delete();
                }
            }

            /*Ajustes do Mapa*/
            $ajusteapurcontr = Ajusteapurcontr::findByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            if (is_array($ajusteapurcontr)) {
                foreach ($ajusteapurcontr as $registro) {
                    $registro->delete();
                }
            }

            /*Impostonf*/
            $impostonf = Impostonf::findByNrsequmapapuAndNrorg($nrsequmapapu, $nrorg);
            if ($impostonf != null) {
                foreach ($impostonf as $registro) {
                    $registro->setNrsequmapapu(null);
                    $registro->persist();
                }

            }

            $impostonf = Impostonf::findByNrseqmapoimpAndNrorg($nrsequmapapu, $nrorg);
            if ($impostonf != null) {
                foreach ($impostonf as $registro) {
                    $registro->setNrseqmapoimp(null);
                    $registro->persist();
                }
            }

            Registry::getEntityManager()->flush();
            $connection->commit();
        } catch (\Exception $e){
            $connection->rollBack();
            throw $e;
        }
    }

    public static function retornaLivroPadrao($nrorg)
    {
        try {
            $livromagnetico = Livromagnetico::getObjectByWhere("IDPADRAOLIVRO = 'S' AND NRORG = ?", array($nrorg));
            $cdlivromag = $livromagnetico->getCdlivromag();
            return $cdlivromag;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /**
     * Valida se jÃ¡ existe a conta, um nÃ­vel superior ou inferior jÃ¡ cadastrado.
     * Caso jÃ¡ exista Ã© exibida uma mensagem informando para qual cst estÃ¡ cadastrado.
     * @param $cdempresa
     * @param $cdcontctbl
     * @param $nrorg
     * @throws \Exception
     */
    public static function validaCadastroContaCont($cdempresa, $cdcontctbl, $nrorg)
    {
        try {
            $contctbl = Contctbl::findOneByCdcontctblAndNrorg($cdcontctbl, $nrorg);
            $cdnvcontctbl = $contctbl->getCdnvcontctbl();

            $erro = Outreccontctbl::testaContaContabil($cdempresa, $cdcontctbl, $cdnvcontctbl, $nrorg);

            if ($erro != null) {

                $cdsitutribpico = $erro[0]['CDSITUTRIBPICO'];
                $iderro = $erro[0]['IDERRO'];

                switch ($iderro) {
                    case 'S': ExcecaoContribuicoes::Validacao09($cdsitutribpico);
                    case 'E': ExcecaoContribuicoes::Validacao10($cdsitutribpico);
                    case 'I': ExcecaoContribuicoes::Validacao11($cdsitutribpico);
                }
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    // Formata a data de forma que possa ser inserida no banco
    public static function formataData($data)
    {
        if (strlen($data) == 19)
            $data = \Geral\Util\DateUtil::truncateString($data);
        $data = \Geral\Util\DateUtil::getDataDeString($data);
        $data = \Geral\Util\DateUtil::truncateData($data);

        return $data;
    }

    public static function insertDetapuracontr($mapa, $zero, $data, $operador, $organizacao)
    {
        try {
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->beginTransaction();

            /** @var Detapuracontr $detapuracontr */
            $detapuracontr = new Detapuracontr();
            $detapuracontr->setNrsequmapapu($mapa);
            $detapuracontr->setVrcancdevol($zero);
            $detapuracontr->setVrcredperant($zero);
            $detapuracontr->setVrcredentr($zero);
            $detapuracontr->setVrcreddevol($zero);
            $detapuracontr->setVrdeducao($zero);
            $detapuracontr->setVrcredativimob($zero);
            $detapuracontr->setVroutreccont($zero);
            $detapuracontr->setVrdevolcomp($zero);
            $detapuracontr->setVrdebncumula($zero);
            $detapuracontr->setVrdebcumula($zero);
            $detapuracontr->setVrdebidevol($zero);
            $detapuracontr->setVrdebecf($zero);
            $detapuracontr->setVrcompensa($zero);
            $detapuracontr->setVrsaldocred($zero);
            $detapuracontr->setNrorg($organizacao);
            $detapuracontr->setDtinclusao(self::formataData($data));
            $detapuracontr->setDtultatu(self::formataData($data));
            $detapuracontr->setNrorginclusao($organizacao);
            $detapuracontr->setNrorgultatu($organizacao);
            $detapuracontr->setCdoperinclusao($operador);
            $detapuracontr->setCdoperultatu($operador);
            $detapuracontr->persist();

            $connection->commit();
            $connection->flush();
        } catch (\Exception $e) {
            TratamentoDeMensagens::exibirMensagens($e, true);
        }
    }

}